=== debian/control ===
Source: centreon-connectors
Section: net
Priority: optional
Maintainer: Freexian Packaging Team <team+freexian@tracker.debian.org>
Uploaders: Sebastien Delafond <seb@debian.org>
Build-Depends: debhelper (>= 11), cmake, libcentreon-clib, pkg-config, libssh2-1-dev, libperl-dev
Standards-Version: 4.2.1
Homepage: https://github.com/centreon/centreon-connectors
Vcs-Browser: https://salsa.debian.org/centreon-team/centreon-connectors
Vcs-Git: https://salsa.debian.org/centreon-team/centreon-connectors.git

Package: centreon-connector-ssh
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Network, system, applicative supervision and monitoring - ssh connector
 Centreon is a modular and flexible platform for network, system and
 applicative supervision and monitoring.
 .
  * monitoring of network services
  * monitoring of host resources
  * simple plugin design that allows users to easily develop their own
    service checks
  * parallelized service checks
  * ability to define network hierarchies
  * contact notifications when service or host problems occur and get
    resolved (via email, page, or user-defined method)
  * ability to define event handlers to be run during service or host
    events for proactive problem resolution
  * automatic log file rotation
  * support for implementing redundant monitoring hosts
 .
 This package contains the ssh connector.

Package: centreon-connector-perl
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Network, system, applicative supervision and monitoring - perl connector
 Centreon is a modular and flexible platform for network, system and
 applicative supervision and monitoring.
 .
  * monitoring of network services
  * monitoring of host resources
  * simple plugin design that allows users to easily develop their own
    service checks
  * parallelized service checks
  * ability to define network hierarchies
  * contact notifications when service or host problems occur and get
    resolved (via email, page, or user-defined method)
  * ability to define event handlers to be run during service or host
    events for proactive problem resolution
  * automatic log file rotation
  * support for implementing redundant monitoring hosts
 .
 This package contains the perl connector.
