## centreon-connectors 19.10.0

=== perl/build/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 ##
-## Copyright 2011-2015,2017-2018 Centreon
+## Copyright 2011-2015,2017-2019 Centreon
 ##
 ## Licensed under the Apache License, Version 2.0 (the "License");
 ## you may not use this file except in compliance with the License.
@@ -26,7 +26,7 @@
 include_directories("${PROJECT_SOURCE_DIR}/inc")
 
 # Project version.
-set(CONNECTOR_PERL_MAJOR 18)
+set(CONNECTOR_PERL_MAJOR 19)
 set(CONNECTOR_PERL_MINOR 10)
 set(CONNECTOR_PERL_PATCH 0)
 set(CONNECTOR_PERL_VERSION "${CONNECTOR_PERL_MAJOR}.${CONNECTOR_PERL_MINOR}.${CONNECTOR_PERL_PATCH}")
