=== debian/changelog ===
centreon-connectors (19.10.0-1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 19:15:28 +0100

centreon-connectors (19.10.0-1) unstable; urgency=medium

  * Add debian/watch
  * New upstream version 19.10.0
  * Bump up Standards-Version

 -- Sebastien Delafond <seb@debian.org>  Fri, 27 Dec 2019 08:03:21 +0100
