=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Freexian Packaging Team <team+freexian@tracker.debian.org>
 Uploaders: Sebastien Delafond <seb@debian.org>
 Build-Depends: debhelper (>= 11), cmake, libcentreon-clib, pkg-config, libssh2-1-dev, libperl-dev
-Standards-Version: 4.2.1
+Standards-Version: 4.4.1
 Homepage: https://github.com/centreon/centreon-connectors
 Vcs-Browser: https://salsa.debian.org/centreon-team/centreon-connectors
 Vcs-Git: https://salsa.debian.org/centreon-team/centreon-connectors.git
